/*
 * Factory.java
 *
 * Created on 26 July 2000, 08:05
 */

package com.hp.hpl.mesa.rdf.exp.model;

/**
 *
 * @author  bwm
 * @version 
 */
public interface Factory {
    public Resource  createResource()                                   throws RDFException;
    public Resource  createResource(Resource type)                      throws RDFException;
    public Resource  createResource(String uri)                         throws RDFException;
    public Resource  createResource(String uri, Resource type)          throws RDFException;
    public Property  createProperty(String uri)                         throws RDFException;
    public Property  createProperty(String nameSpace, String localName) throws RDFException;
    public Literal   createLiteral(boolean b)                           throws RDFException;
    public Literal   createLiteral(byte b)                              throws RDFException;
    public Literal   createLiteral(short s)                             throws RDFException;
    public Literal   createLiteral(int i)                               throws RDFException;
    public Literal   createLiteral(long l)                              throws RDFException;
    public Literal   createLiteral(char c)                              throws RDFException;
    public Literal   createLiteral(float f)                             throws RDFException;
    public Literal   createLiteral(double d)                            throws RDFException;
    public Literal   createLiteral(String s)                            throws RDFException;
    public Literal   createLiteral(Object o)                            throws RDFException;
    public Statement createStatement(Resource r, Property p, RDFNode n) throws RDFException;
    public Statement createStatement(Resource r, Property p, boolean b) throws RDFException;
    public Statement createStatement(Resource r, Property p, byte b)    throws RDFException;
    public Statement createStatement(Resource r, Property p, short b)   throws RDFException;
    public Statement createStatement(Resource r, Property p, int b)     throws RDFException;
    public Statement createStatement(Resource r, Property p, long)      throws RDFException;
    public Statement createStatement(Resource r, Property p, char b)    throws RDFException;
    public Statement createStatement(Resource r, Property p, float b)   throws RDFException;
    public Statement createStatement(Resource r, Property p, double b)  throws RDFException;
    public Statement createStatement(Resource r, Property p, String b)  throws RDFException;
    public Statement createStatement(Resource r, Property p, Object b) throws RDFException;
    public Container createBag()                                        throws RDFException;
    public Container createBag(String uri)                              throws RDFException;
    public Container createAlt()                                        throws RDFException;
    public Container createAlt(String uri)                              throws RDFException;
    public Container createSeq()                                        throws RDFException;
    public Container createSeq(String uri)                              throws RDFException;
}
